=== test/narrowphase/CMakeLists.txt ===
add_subdirectory(detail)
