=== test/narrowphase/detail/CMakeLists.txt ===
add_subdirectory(convexity_based_algorithm)
add_subdirectory(primitive_shape_algorithm)
