=== debian/changelog ===
fcl (0.6.1-5) unstable; urgency=medium

  * Uploaded version to unstable.
  * Transition initiated to libfcl0.6.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Thu, 31 Dec 2020 18:21:41 +0100

fcl (0.6.1-4) experimental; urgency=medium

  * Using parallel=1 on mipsel.
  * Added some magic rules to build it in mipsel. Thanks YunQiang Su.
  * Drop old dependencies.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 29 Dec 2020 20:22:42 +0100

fcl (0.6.1-3) experimental; urgency=medium

  * Team upload.

  [ Timo Röhling ]
  * Bump to debhelper compat 13
  * Fix issue with uninstalled files
  * Add patches:
    - Fix typo
    - Call abort() instead of exit(1) on OOM condition
    - Replace memcpy with std::copy
  * Enable all hardening and reproducibility features
  * Ignore non-amd64 test failures for now

  [ Jochen Sprickerhof ]
  * bump policy version (no changes)
  * Update Homepage
  * minor cleanup

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 21 Nov 2020 10:09:00 +0100

fcl (0.6.1-2) experimental; urgency=medium

  * Team upload.
  * Add R³
  * add Salsa CI
  * Simplify d/rules

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 08 May 2020 15:15:20 +0200

fcl (0.6.1-1) experimental; urgency=medium

  [ Jose Luis Rivero ]
  * Migrate to debhelper-compat
  * Missing entries in copyright
  * Fix cmake bug disabling SSE detection which ends up in march=native
  * Update watch
  * New upstream version 0.6.1
  [ Jelmer Vernooĳ ]
  * Remove unnecessary 'Testsuite: autopkgtest' header.
  * Use secure copyright file specification URI.
  * Trim trailing whitespace.

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 10 Feb 2020 16:11:41 +0100
