=== debian/control ===
Source: fcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               libccd-dev,
               liboctomap-dev,
               libeigen3-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/fcl
Vcs-Git: https://salsa.debian.org/science-team/fcl.git
Homepage: https://flexible-collision-library.github.io/

Package: libfcl0.6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Flexible Collision Library - shared library
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. The library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models. This package contains the library.

Package: libfcl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libccd-dev,
         liboctomap-dev,
         libeigen3-dev,
         libfcl0.6 (= ${binary:Version}),
         ${misc:Depends}
Description: Flexible Collision Library - development files
 FCL is a collision and proximity library that integrates several techniques for
 fast and accurate collision checking and proximity computation. The library is
 based on hierarchical representations and designed to perform multiple
 proximity queries on different model representations. The set of queries
 includes discrete collision detection, continuous collision detection,
 separation distance computation and penetration depth estimation. The input
 models may correspond to triangulated rigid or deformable models and
 articulated models. This package contains the development files.
