=== debian/tests/control ===
Tests: build
Depends: libfcl-dev, build-essential
