=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/fcl-$1\.tar\.gz/ \
     https://github.com/flexible-collision-library/fcl/tags .*v(\d\S+)\.tar\.gz
