=== test/narrowphase/detail/convexity_based_algorithm/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
     test_gjk_libccd-inl_epa.cpp
     test_gjk_libccd-inl_extractClosestPoints.cpp
     test_gjk_libccd-inl_gjk_doSimplex2.cpp
+    test_gjk_libccd-inl_gjk_initializer.cpp
 )
 
 # Build all the tests
