=== test/narrowphase/detail/primitive_shape_algorithm/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 set(tests
     test_sphere_box.cpp
     test_sphere_cylinder.cpp
+    test_half_space_convex.cpp
 )
 
 # Build all the tests
