=== debian/changelog ===
fcl (0.7.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:13:53 +0000

fcl (0.7.0-3build1) noble; urgency=high

  * No change rebuild against liboctomap1.9t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:01:01 +0100

fcl (0.7.0-3) unstable; urgency=medium

  * Move to unstable

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 15 Oct 2021 22:46:53 +0200

fcl (0.7.0-2) experimental; urgency=medium

  * Added patch for sparc64

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 12 Oct 2021 19:40:01 +0000

fcl (0.7.0-1) experimental; urgency=medium

  * Bump standard 4.6.0
  * Simplify watch file
  * New upstream version 0.7.0
  * Rename packages to 0.7 SONAME
  * Remove all patches, they were merged upstream

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 10 Sep 2021 20:19:43 +0000
