=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: fcl
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
 Section: science
@@ -10,13 +11,13 @@
                libccd-dev,
                liboctomap-dev,
                libeigen3-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/fcl
 Vcs-Git: https://salsa.debian.org/science-team/fcl.git
 Homepage: https://flexible-collision-library.github.io/
 
-Package: libfcl0.6
+Package: libfcl0.7
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -39,7 +40,7 @@
 Depends: libccd-dev,
          liboctomap-dev,
          libeigen3-dev,
-         libfcl0.6 (= ${binary:Version}),
+         libfcl0.7 (= ${binary:Version}),
          ${misc:Depends}
 Description: Flexible Collision Library - development files
  FCL is a collision and proximity library that integrates several techniques for
