=== debian/watch ===
version=4
opts=compression=xz \
  https://github.com/flexible-collision-library/fcl/tags .*(\d+.\d+.\d+)\.tar\.gz
